import Web3 from 'web3';
import { PastEventOptions } from 'web3-eth-contract';
import { GeneralFunctions, ISpecialTx, Timestamp } from '@energyweb/utils-general';
export declare class Issuer extends GeneralFunctions {
    web3: Web3;
    constructor(web3: Web3, address?: string);
    initialize(certificateTopic: number, registryAddress: string, owner: string, txParams: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    getAllEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    getAllNewCertificationRequestEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    encodeData(_from: Timestamp, _to: Timestamp, _deviceId: string, txParams?: ISpecialTx): Promise<any>;
    decodeData(_data: number[], txParams?: ISpecialTx): Promise<any>;
    getCertificationRequest(_certificationRequestId: number, txParams?: ISpecialTx): Promise<any>;
    getCertificationRequestsForDevice(_deviceId: string, txParams?: ISpecialTx): Promise<number[]>;
    getCertificateCommitment(_certificateId: number, txParams?: ISpecialTx): Promise<any>;
    requestCertification(_data: any, _isPrivate: boolean, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    requestCertificationFor(_data: any, _forAddress: string, _isPrivate: boolean, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    approveCertificationRequest(_requestId: number, _value: number, _validityData: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    issue(_to: string, _value: number, _data: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    approveCertificationRequestPrivate(_requestId: number, _commitment: string, _validityData: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    issuePrivate(_to: string, _commitment: string, _data: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    revokeRequest(_requestId: number, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    revokeCertificate(_certificateId: number, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    updateCommitment(_id: number, _previousCommitment: string, _commitment: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    requestMigrateToPublic(_certificateId: number, _hash: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    getPrivateTransferRequest(_certificateId: number, txParams?: ISpecialTx): Promise<any>;
    getMigrationRequestId(_certificateId: number, txParams?: ISpecialTx): Promise<any>;
    getMigrationRequest(_requestId: number, txParams?: ISpecialTx): Promise<any>;
    migrateToPublic(_requestId: number, _value: number, _salt: string, _proof: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    approvePrivateTransfer(_certificateId: number, _proof: any, _previousCommitment: string, _commitment: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    requestPrivateTransfer(_certificateId: number, _hash: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    getCertificationRequestForCertificate(_certificateId: number, txParams?: ISpecialTx): Promise<any>;
    getCertificationRequestIdForCertificate(_certificateId: number, txParams?: ISpecialTx): Promise<number>;
    getCertificateIdForCertificationRequest(_requestId: number, txParams?: ISpecialTx): Promise<number>;
    getRegistryAddress(txParams?: ISpecialTx): Promise<any>;
    totalRequests(txParams?: ISpecialTx): Promise<any>;
    version(txParams?: ISpecialTx): Promise<any>;
}
